#### POSIX Threads for Windows – REFERENCE - Pthreads-w32

Reference Index

Table of Contents

## Name

pthread_rwlock_trywrlock, pthread_rwlock_wrlock - lock a read-write lock object for writing

## Synopsis

#include <pthread.h>

int pthread_rwlock_trywrlock(pthread_rwlock_t *rwlock);
int pthread_rwlock_wrlock(pthread_rwlock_t *rwlock);

## Description

The pthread_rwlock_trywrlock function shall apply a write lock like the pthread_rwlock_wrlock function, with the exception that the function shall fail if any thread currently holds rwlock (for reading or writing).

The pthread_rwlock_wrlock function shall apply a write lock to the read-write lock referenced by rwlock. The calling thread acquires the write lock if no other thread (reader or writer) holds the read-write lock rwlock. Otherwise, the thread shall block until it can acquire the lock. The calling thread may deadlock if at the time the call is made it holds the read-write lock (whether a read or write lock).

Pthreads-win32 does not prefer either writers or readers in acquiring the lock – all threads enter a single prioritised FIFO queue. While this may not be optimally efficient for some applications, it does ensure that one type does not starve the other.

Results are undefined if any of these functions are called with an uninitialized read-write lock.

Pthreads-w32 defines _POSIX_READER_WRITER_LOCKS in pthread.h as 200112L to indicate that the reader/writer routines are implemented and may be used.

## Return Value

The pthread_rwlock_trywrlock function shall return zero if the lock for writing on the read-write lock object referenced by rwlock is acquired. Otherwise, an error number shall be returned to indicate the error.

If successful, the pthread_rwlock_wrlock function shall return zero; otherwise, an error number shall be returned to indicate the error.

## Errors

The pthread_rwlock_trywrlock function shall fail if:

EBUSY
  The read-write lock could not be acquired for writing because it was already locked for reading or writing.

The pthread_rwlock_trywrlock and pthread_rwlock_wrlock functions may fail if:

EINVAL
  The value specified by rwlock does not refer to an initialized read-write lock object.

These functions shall not return an error code of [EINTR].

The following sections are informative.

## Examples

None.

## Application Usage

Applications using these functions may be subject to priority inversion, as discussed in the Base Definitions volume of IEEE Std 1003.1-2001, Section 3.285, Priority Inversion.

## Rationale

None.

## Future Directions

None.

## See Also

pthread_rwlock_destroy(3) , pthread_rwlock_rdlock(3) , pthread_rwlock_timedrdlock(3) , pthread_rwlock_timedwrlock(3) , pthread_rwlock_tryrdlock(3) , pthread_rwlock_unlock(3) , the Base Definitions volume of IEEE Std 1003.1-2001, <pthread.h>

## Copyright

Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .

Modified by Ross Johnson for use with Pthreads-w32.

Table of Contents

- Name

- Synopsis

- Description

- Return Value

- Errors

- Examples

- Application Usage

- Rationale

- Future Directions

- See Also

- Copyright